
module Gargantext.API.GraphQL.Types where

import Control.Monad.Fail (fail)
import Data.Morpheus.Types
import Data.Text qualified as T
import Gargantext.API.Prelude
import Gargantext.API.Errors.Types
-- import Gargantext.Core.Types (NodeId(UnsafeMkNodeId))
-- import Gargantext.Database.Query.Table.Node.Error (NodeError(NodeLookupFailed), NodeLookupError(NodeDoesNotExist))
import Gargantext.Prelude

type GqlM e env = Resolver QUERY e (GargM env BackendInternalError)
type GqlM' e env a = ResolverM e (GargM env BackendInternalError) a

-- nodeDoesNotExistError :: Int -> BackendInternalError
-- nodeDoesNotExistError nodeId =
--   InternalNodeError $ NodeLookupFailed $ NodeDoesNotExist $ UnsafeMkNodeId nodeId

gqlHead :: Show params => (Text, params) -> [a] -> GqlM e env a
gqlHead (err, params) els =
  case head els of
    Just el -> pure el
    Nothing -> fail $ T.unpack err <> show params
